<?php
/******************************
 WOW Roster SMF bridge by Haiduk
 
*******************************/

function Load_SMF_Bridge()
{
  $DEBUG=false;
//  echo '<font color="#808080">';

  $ret['using_smf']=false;
  $ret['user_id']=0;       
  $ret['board_url']=0;       
  $ret['board_dir']=0;
  $ret['allowed_to_view']=0;
  $ret['allowed_to_update']=0;
  $ret['allowed_to_admin']=0;
  
  if (!isset($_COOKIE['SMFMOD']) || !isset($_COOKIE['SMFURL']) || !isset($_COOKIE['SMFDIR']))
  {
    return;
  }
  

  // locate the SMF folder/directory
  if (isset($_COOKIE['SMFURL']))
  {
    $ret['board_url'] = $_COOKIE['SMFURL'];
  }
  if (isset($_COOKIE['SMFDIR']))
  {
    $ret['board_dir'] = $_COOKIE['SMFDIR'];
  }
  # Make sure the paths are correct... at least try to fix them.
  // SMF in the same folder as ROSTER?
  if (!file_exists($ret['board_dir']) && file_exists(dirname(__FILE__) . '/agreement.txt'))
  	$ret['board_dir'] = dirname(__FILE__);
  // SMF in the parent folder of ROSTER?
  if (!file_exists($ret['board_dir']) && file_exists(dirname(dirname(__FILE__)) . '/agreement.txt'))
  	$ret['board_dir'] = dirname(dirname(__FILE__));
  // SMF in the parent of the parent?
  if (!file_exists($ret['board_dir']) && file_exists(dirname(dirname(dirname(__FILE__))) . '/agreement.txt'))
  	$ret['board_dir'] = dirname(dirname(dirname(__FILE__)));
  // SMF in the parent of the parent of the parent?
  if (!file_exists($ret['board_dir']) && file_exists(dirname(dirname(dirname(dirname(__FILE__)))) . '/agreement.txt'))
  	$ret['board_dir'] = dirname(dirname(dirname(dirname(__FILE__))));
  // SMF is in a folder in the same folder as ROSTER? (check through a few common smf folder names)
  $smf=array('smf', 'SMF', 'forum', 'Forum', 'forums', 'Forums');
  foreach($smf as $s)
  {
    if (!file_exists($ret['board_dir']) && file_exists(dirname(__FILE__) . '/'.$s.'/agreement.txt'))
    {
      $ret['board_dir'] = dirname(__FILE__) . '/'.$s.'/agreement.txt';
      break;
    }
  }
  
  // Load SMF Settings
  if (file_exists($ret['board_dir'].'/Settings.php'))
  {
    // Load the settings...
    require($ret['board_dir'] . '/Settings.php');
    
    $allowedto_view=false;
    $allowedto_update=false;
    $allowedto_admin=false;
    
    // Connect to the MySQL database.
    define('SMF', 1);
    require_once($ret['board_dir'].'/Sources/Subs.php');
    if (empty($db_persist))
    	$db_connection = mysql_connect($db_server, $db_user, $db_passwd);
    else
    	$db_connection = mysql_pconnect($db_server, $db_user, $db_passwd);

    // Show an error if the connection couldn't be made.
    if (!$db_connection || !mysql_select_db($db_name, $db_connection))
    	die('<font size="5"<b>Failed to Connect to Database!</b></font>');  

    $ID_MEMBER = 0;

    if (isset($_COOKIE['SMFMOD']))
    {
      $cook=$_COOKIE['SMFMOD'];
      $sql='SELECT ID_MEMBER FROM '.$db_prefix.'members';
      $dbresult = mysql_query("SELECT ID_MEMBER FROM {$db_prefix}members");
      while($row = mysql_fetch_assoc($dbresult))
      {
        $uid=(int)$row['ID_MEMBER'];
        if (md5(serialize($uid)) === $cook)
        {
          $ID_MEMBER=$uid;
          break;
        }
      }
      mysql_free_result($dbresult);    
    }

    $permissions=fetchPermissions($ID_MEMBER, $db_prefix);    
    
    $ret['user_id']=$ID_MEMBER;       
    $ret['allowed_to_view']=$permissions['allowed_to_view'];
    $ret['allowed_to_update']=$permissions['allowed_to_update'];
    $ret['allowed_to_admin']=$permissions['allowed_to_admin'];  
    if (isset($_COOKIE['SMFMOD']) && isset($_COOKIE['SMFURL']) && isset($_COOKIE['SMFDIR']))
      $ret['using_smf'] = true;
  }  
  if ($DEBUG)
  {
    echo '<font color="#808080">';
    echo 'Using SMF: '.$ret['using_smf'].'<br>';
    echo 'SMF user id: '.$ret['user_id'].'<br>';
    echo 'SMF board url: '.$ret['board_url'].'<br>';
    echo 'SMF board dir: '.$ret['board_dir'].'<br>';
    echo 'Allowed to View: '.(($ret['allowed_to_view']) ? 'true<br>' : 'false<br>');
    echo 'Allowed to Admin: '.(($ret['allowed_to_admin']) ? 'true<br>' : 'false<br>');
    echo 'Allowed to Update: '.(($ret['allowed_to_update']) ? 'true<br>' : 'false<br>');
  }
  return $ret;
}

function fetchPermissions($UserID=0, $db_prefix='smf_')
{ 
  // guests are coming up as ID_GROUP = -1
  // Regular Members  as ID_GROUP = 0
  // Admin  as ID_GROUP = 1
  
  // build a list of GROUP_ID's of all membergroups containing one of the wowroster permissions
  $dbresult = @mysql_query(
    "SELECT * FROM {$db_prefix}permissions 
      WHERE 
        permission = 'wowroster_view' OR
        permission = 'wowroster_admin' OR
        permission = 'wowroster_update'");  
  $gi=0;
  while($row = @mysql_fetch_assoc($dbresult))
  {
    if (isset($row['ID_GROUP']))
      $group[$gi]['ID_GROUP']=$row['ID_GROUP'];
    if (isset($row['permission']))
      $group[$gi]['permission']=$row['permission'];
    if (isset($row['groupName']))
      $group[$gi]['groupName']=$row['groupName'];
    $gi++;
  }
  @mysql_free_result($dbresult);   

  $ret['allowed_to_view']=false;
  $ret['allowed_to_admin']=false;
  $ret['allowed_to_update']=false;
  
  // guests are in membergroup -1
  if ($UserID === 0)
  {
    foreach($group as $g)
    {
      if ($g['ID_GROUP'] === '-1')
      {
        if ($g['permission'] === 'wowroster_view')
          $ret['allowed_to_view']=true;
        if ($g['permission'] === 'wowroster_admin')
          $ret['allowed_to_admin']=true;
        if ($g['permission'] === 'wowroster_update')
          $ret['allowed_to_update']=true;          
      }
    }
    return $ret;
  }
  
  $dbresult = mysql_query(
    "SELECT * FROM {$db_prefix}members 
      WHERE 
        ID_MEMBER = '$UserID'");  
  if($row = mysql_fetch_assoc($dbresult))
  {
    if ($row['ID_GROUP']==='1')   
    {
      // admin?
      $ret['allowed_to_view']=true;
      $ret['allowed_to_admin']=true;
      $ret['allowed_to_update']=true;
      return $ret;
    }
    // regular members
    foreach($group as $g)
    {
      // check primary membergroup
      if ($row['ID_GROUP']===$g['ID_GROUP'])
      {
        if ($g['permission'] === 'wowroster_view')
          $ret['allowed_to_view']=true;
        if ($g['permission'] === 'wowroster_admin')
          $ret['allowed_to_admin']=true;
        if ($g['permission'] === 'wowroster_update')
          $ret['allowed_to_update']=true;          
      }
      // check additional groups
      $AddGroups=$row['additionalGroups'];
      if ($AddGroups!='')
      {
        $AG=explode(',', $AddGroups);
        foreach($AG as $gid)
        {
          if ($g['ID_GROUP']===$gid)
          {
            if ($g['permission'] === 'wowroster_view')
              $ret['allowed_to_view']=true;
            if ($g['permission'] === 'wowroster_admin')
              $ret['allowed_to_admin']=true;
            if ($g['permission'] === 'wowroster_update')
              $ret['allowed_to_update']=true;          
          }
        }
      }
    }
  }
  return $ret;
}

?>